import threading
import time
from time import sleep

import polling


start_cpu_used = None


def get_metrics(start_time):
    global start_cpu_used

    def read_value_from_file(path):
        file = open(path, "rb")
        value = int(file.read())
        file.close()
        return value

    def get_cpu_used():
        # Time in nanoseconds
        # Multiply by 1000000000 to get to seconds
        return read_value_from_file("/sys/fs/cgroup/cpu/cpuacct.usage_user")

    def get_cpu_available():
        # Times in microseconds
        cpu_quota = read_value_from_file("/sys/fs/cgroup/cpu/cpu.cfs_quota_us")
        cpu_period = read_value_from_file("/sys/fs/cgroup/cpu/cpu.cfs_period_us")
        return float(cpu_quota / cpu_period)

    start_cpu_used = start_cpu_used or get_cpu_used()

    print(start_time)
    print(start_cpu_used)

    now_time = int(time.time())
    now_cpu_used = get_cpu_used()
    print(now_time)
    print(now_cpu_used)

    diff_time = now_time - start_time
    diff_cpu = now_cpu_used - start_cpu_used
    print(diff_time)
    print(diff_cpu)

    cpus_available = get_cpu_available()
    print(cpus_available)

    cpus_used = float(diff_cpu / diff_time / 1000000000)
    print(f"CPUs used: {cpus_used:.2f} ({cpus_available} available)")

    fabric_cpu_utilisation = cpus_used * 100 / cpus_available
    print(f"Fabric's CPU Utilisation: {fabric_cpu_utilisation:.2f} %")


def monitor_system_metrics(stop):
    start_time = int(time.time())
    sleep(1)  # helps keep things simple
    polling.poll(
        lambda: get_metrics(start_time),
        step=1,  # anything under 1 second risks divisions by zero, stick with >=1
        check_success=stop,
        poll_forever=True,
    )


stop_system_metrics_thread = False
system_metrics_thread = threading.Thread(
    target=monitor_system_metrics, args=(lambda x: stop_system_metrics_thread,)
)

system_metrics_thread.start()
sleep(10)
stop_system_metrics_thread = True
system_metrics_thread.join()
print("Stopped")
